# -*- coding: utf-8 -*-
import os
import types

from PyQt4.QtCore import *
from PyQt4.QtGui import *
#from Messaging import stdMsg, dbgMsg,pd, errMsg, setDebugging

import Configuration
#import ConfigurationPageBase
from ConfigurationPageBase import ConfigurationPageBase

import ui_configurationdlg  # the file generated by 'pyuic4' using the .ui Designer file

MAC = "qt_mac_set_native_menubar" in dir()

MODULENAME = '------- ConfigurationDialog.py: '


class ConfigurationDialog(QDialog, ui_configurationdlg.Ui_CC3DPrefs, ConfigurationPageBase):
   
    def __init__(self, parent = None, name = None, modal = False):
        QDialog.__init__(self, parent)
        self.setModal(modal)
        
#        self.config = Configuration()
        
        self.paramCC3D = {}   #  dict for ALL parameters on CC3D Preferences dialog
        self.initParams()  # read params from QSession file
        
        self.setupUi(self)   # in ui_configurationdlg.Ui_CC3DPrefs
  
#        if not MAC:
#            self.cancelButton.setFocusPolicy(Qt.NoFocus)
#        self.updateUi()

        # ------- the following 'connect' method basically establish callback methods -----------
#        self.tabWidget.currentChanged.connect(currentChanged)
#        self.connect(self.tabWidget,   SIGNAL("currentChanged()"),       self.currentChanged)
        self.tabWidget.currentChanged.connect(self.currentTabChanged)
        
        # Output tab
        self.outputImagesCheckBox.clicked.connect(self.outputImagesClicked)
        self.outputLatticeDataCheckBox.clicked.connect(self.outputLatticeDataClicked)
        
        # Cell Type/Colors tab
        self.typeColorTable.clicked.connect(self.typeColorTableClicked)
        
        self.cellBorderColorButton.clicked.connect(self.cellBorderColorClicked)
        self.clusterBorderColorButton.clicked.connect(self.clusterBorderColorClicked)
        self.contourColorButton.clicked.connect(self.contourColorClicked)
        
        # Colormap tab
        # The following will constrain the input to be valid (double) numeric values
        cmapMinValid = QDoubleValidator(self.cmapMinRange)
        self.cmapMinRange.setValidator(cmapMinValid)
        cmapMaxValid = QDoubleValidator(self.cmapMaxRange)
        self.cmapMaxRange.setValidator(cmapMaxValid)
        
        self.cmapMinRangeFixedCheckBox.clicked.connect(self.cmapMinRangeClicked)
        self.cmapMaxRangeFixedCheckBox.clicked.connect(self.cmapMaxRangeClicked)
        
        # Vectors tab
        minVecValid = QDoubleValidator(self.vectorsMinMag)
        self.vectorsMinMag.setValidator(minVecValid)
        maxVecValid = QDoubleValidator(self.vectorsMaxMag)
        self.vectorsMaxMag.setValidator(maxVecValid)
        
        self.vectorsMinMagFixedCheckBox.clicked.connect(self.vectorsMinMagClicked)
        self.vectorsMaxMagFixedCheckBox.clicked.connect(self.vectorsMaxMagClicked)
        
        self.vectorsArrowColorCheckBox.clicked.connect(self.vectorsArrowColorClicked)
        self.vectorsArrowColorButton.clicked.connect(self.vectorsArrowColorButtonClicked)
        
#        self.connect(self.buttonBox,   SIGNAL("accepted()"),       self.accept)  # done implicitly
#        self.connect(self.buttonBox,   SIGNAL("rejected()"),       self.reject)  # done implicitly


#        self.connect(self.configWidget.buttonBox,   SIGNAL("rejected()"),       self.reject)
#        self.connect(self.configWidget,             SIGNAL('configsChanged'),   self.__configsChanged)
        self.updateUI()
        
#        self.connect(self.tabWidget,   SIGNAL("currentChanged()"),       self.tabChanged)
        

#    @pyqtSignature("")
#    def on_borderColorButton_clicked(self):
#        print MODULENAME,'  on_borderColorButton_clicked'
        
#    @tabWidget.currentChanged.connect

    #----------- following methods are callbacks from the above "connect"s  ------------
    def currentTabChanged(self):
#        print MODULENAME,' ------ tab changed()'
#        print '      tab currentIndex =',self.tabWidget.currentIndex()
        Configuration.setSetting("TabIndex", self.tabWidget.currentIndex())
    
    # -------- Output widgets CBs
    def outputImagesClicked(self):
        if self.outputImagesCheckBox.isChecked():
            self.saveImageSpinBox.setEnabled(True)
            
        else:
            self.saveImageSpinBox.setEnabled(False)
            
            
    def outputLatticeDataClicked(self):
        if self.outputLatticeDataCheckBox.isChecked():
            self.saveLatticeSpinBox.setEnabled(True)
            
        else:
            self.saveLatticeSpinBox.setEnabled(False)
            
        
    # -------- Cell Type (colors) widgets CBs
    def typeColorTableClicked(self):
#        print MODULENAME,"    typeColorTableClicked"
        row = self.typeColorTable.currentRow()
        col = self.typeColorTable.currentColumn()
        print "  current row,col=",row,col
        self.typeColorTable.setCurrentCell(row,0)  # highlight the left column cell (cell #), not cell w/ the color
        item = self.typeColorTable.item(row,1)
#        if row == 0 or col == 0: return  # ECM is special; only proceed with color dialog/selection if user chose color column
        keys = self.paramCC3D["TypeColorMap"].keys()
        print 'keys= ',keys
#            item = QTableWidgetItem()
        
#            item.setBackground(QBrush(self.paramCC3D["TypeColorMap"][keys[row]]))
#            self.typeColorTable.setItem(row, 1, item)
#            cellColor = QColor(Qt.yellow)
        cellColor = self.paramCC3D["TypeColorMap"][keys[row]]
        color = QColorDialog.getColor(cellColor)
        if color.isValid():
            print 'color= ',color
            print 'rgb= ',color.red(),color.green(),color.blue()
            self.paramCC3D["TypeColorMap"][keys[row]] = color
#            Configuration.setSetting("TypeColorMap",self.paramCC3D["TypeColorMap"])  # is this necessary yet?
            item.setBackground(QBrush(color))
#            self.populateCellColors()
            
         
#         color = self.selectColor(self.clusterBorderColorButton, Configuration.getSetting("ClusterBorderColor"))
#         print '      typeColorTableClicked: color=',color.red(),color.green(),color.blue()
        
    def updateColorButton(self, btn, name):
        color = self.selectColor(btn, Configuration.getSetting(name))
        print '      updateColorButton: color=',color.red(),color.green(),color.blue()
        # which of the following is necessary at this point?
        Configuration.setSetting(name, color)
        self.paramCC3D[name] = color
        
    def cellBorderColorClicked(self):
#        dbgMsg(MODULENAME,' ------ cellBorderColorClicked()')  # why isn't my 'print' printing?!
        self.updateColorButton(self.cellBorderColorButton, "BorderColor")
#        color = self.selectColor(self.cellBorderColorButton, Configuration.getSetting("BorderColor"))
#        print '      color=',color
#        Configuration.setSetting("BorderColor", color)
        
    def clusterBorderColorClicked(self):
#        print MODULENAME,' ------ clusterBorderColorClicked()'
        self.updateColorButton(self.clusterBorderColorButton, "ClusterBorderColor")
#        color = self.selectColor(self.clusterBorderColorButton, Configuration.getSetting("ClusterBorderColor"))
#        print '      color=',color
#        Configuration.setSetting("ClusterBorderColor", color)
        
    def contourColorClicked(self):
#        print MODULENAME,' ------ countourColorClicked()'
        self.updateColorButton(self.contourColorButton, "ContourColor")
#        color = self.selectColor(self.contourColorButton, Configuration.getSetting("ContourColor"))
#        print '      color=',color
#        Configuration.setSetting("ContourColor", color)


    # -------- Colormap widgets CBs
    def cmapMinRangeClicked(self):
        if self.cmapMinRangeFixedCheckBox.isChecked():
            self.cmapMinRange.setEnabled(True)
            self.cmapMinLabel.setEnabled(True)
        else:
            self.cmapMinRange.setEnabled(False)
            self.cmapMinLabel.setEnabled(False)
            
    def cmapMaxRangeClicked(self):
        if self.cmapMaxRangeFixedCheckBox.isChecked():
            self.cmapMaxRange.setEnabled(True)
            self.cmapMaxLabel.setEnabled(True)
        else:
            self.cmapMaxRange.setEnabled(False)
            self.cmapMaxLabel.setEnabled(False)
            
    # -------- Vectors widgets CBs
    def vectorsMinMagClicked(self):
        if self.vectorsMinMagFixedCheckBox.isChecked():
            self.vectorsMinMag.setEnabled(True)
            self.vectorsMinMagLabel.setEnabled(True)
        else:
            self.vectorsMinMag.setEnabled(False)
            self.vectorsMinMagLabel.setEnabled(False)
            
    def vectorsMaxMagClicked(self):
        if self.vectorsMaxMagFixedCheckBox.isChecked():
            self.vectorsMaxMag.setEnabled(True)
            self.vectorsMaxMagLabel.setEnabled(True)
        else:
            self.vectorsMaxMag.setEnabled(False)
            self.vectorsMaxMagLabel.setEnabled(False)

    def vectorsArrowColorClicked(self):
        if self.vectorsArrowColorCheckBox.isChecked():
            self.vectorsArrowColorButton.setEnabled(True)
        else:
            self.vectorsArrowColorButton.setEnabled(False)
        
    def vectorsArrowColorButtonClicked(self):
        self.updateColorButton(self.vectorsArrowColorButton, "ArrowColor")
        
        
    def accept(self):
#        print MODULENAME, 'accept <<<<<<<<<<<<<----------------'
#        Configuration.setSetting()
        if self.outputImagesCheckBox.isChecked() and (self.saveImageSpinBox.value() < self.updateScreenSpinBox.value()):
            saveImgStr = str(self.saveImageSpinBox.value())
            QMessageBox.warning(None,"WARN","If saving images, you need to Update screen at least as frequently as Save image (e.g. Update screen = "+saveImgStr+')', QMessageBox.Ok)
            return
        
        self.updatePreferences()
        QDialog.accept(self)
        
    def enableLatticeOutput(self, boolFlag):
        self.outputLatticeDataCheckBox.setEnabled(boolFlag)
    
        
#    def reject(self):
#        print MODULENAME, 'reject <<<<<<<<<<<<<----------------'
#        QDialog.reject(self)
#        
#    def apply(self):  # never called
#        print MODULENAME, 'apply <<<<<<<<<<<<<----------------'
#        QDialog.apply(self)
#
#        
#    @pyqtSignature("") # signature of the signal emitted by the button
#    def on_okButton_clicked(self):
#        print MODULENAME, 'on_okButton_clicked <<<<<<<<<<<<<----------------'
#        self.updatePreferences()        
#        self.close()

#    @pyqtSignature("")
#    def on_borderColorButton_clicked(self):
#        """
#        Private slot to set the color for border
#        """
#        print MODULENAME,'-------- on_borderColorButton_clicked --------'
#        self.cellColors["Border"] = self.selectColor(self.borderColorButton, self.cellColors["Border"])

    @pyqtSignature("") # signature of the signal emited by the button
    def on_projectLocationButton_clicked(self):
        currentProjectDir=Configuration.getSetting('ProjectLocation')
        dirName = QFileDialog.getExistingDirectory ( self, "Specify CC3D Project Directory", currentProjectDir, QFileDialog.ShowDirsOnly)
        dirName=str(dirName)
        dirName.rstrip()
        if dirName=="":
            return
        
        dirName=os.path.abspath(dirName)
        self.projectLocationLineEdit.setText(dirName)
        currentProjectDir=Configuration.setSetting('ProjectLocation',dirName)
        
    @pyqtSignature("") # signature of the signal emited by the button
    def on_outputLocationButton_clicked(self):
        currentOutputDir=Configuration.getSetting('OutputLocation')
        dirName = QFileDialog.getExistingDirectory ( self, "Specify CC3D Output Directory", currentOutputDir, QFileDialog.ShowDirsOnly)
        dirName=str(dirName)        
        dirName.rstrip()
        print "dirName=",dirName
        if dirName=="":
            return
        dirName=os.path.abspath(dirName)
        self.outputLocationLineEdit.setText(dirName)
        currentProjectDir=Configuration.setSetting('OutputLocation',dirName)
        
    @pyqtSignature("") # signature of the signal emited by the button
    def on_addCellTypeButton_clicked(self):   
    
        lastRowIdx=self.typeColorTable.rowCount()-1

        typeItem=self.typeColorTable.item(lastRowIdx,0)
        lastTypeNumber,flag=typeItem.text().toInt()
        
        
        if not flag:
            #conversion to integer unsusccesfull
            return
            
        if  lastTypeNumber>=256:
            #cc3d supports only up to 256 cell types
            return
            
        colorItem=self.typeColorTable.item(lastRowIdx,1)
        lastTypeColor=colorItem.background().color()
        self.typeColorTable.insertRow(lastRowIdx+1)

        # fill new row
        self.typeColorTable.setItem(lastRowIdx+1,0,QTableWidgetItem(str(lastTypeNumber+1)))
        self.typeColorTable.setItem(lastRowIdx+1,1,QTableWidgetItem())
        colorITem=self.typeColorTable.item(lastRowIdx+1,1)
        colorITem.setBackground(QBrush(lastTypeColor))
        # init setting dictionary        
        self.paramCC3D["TypeColorMap"][lastRowIdx+1]=lastTypeColor
        
        
    def populateCellColors(self):
#        print MODULENAME,'    populateCellColors'
        rowCount = len(self.paramCC3D["TypeColorMap"])
#        print MODULENAME,"populateCellColors: rowCount=", rowCount
        self.typeColorTable.setRowCount(rowCount)
        keys = self.paramCC3D["TypeColorMap"].keys()
#        print MODULENAME,'    keys= ',keys
        for i in range(rowCount):
            if i==0:
                item = QTableWidgetItem(QString("ECM"))
            else:
                item = QTableWidgetItem(QString("%1").arg(keys[i]))
            self.typeColorTable.setItem(i, 0, item)
            
            item = QTableWidgetItem()
            item.setBackground(QBrush(self.paramCC3D["TypeColorMap"][keys[i]]))
            self.typeColorTable.setItem(i, 1, item)
            
    def updatePreferences(self):
#        print MODULENAME, ' -----------  updatePreferences  -------------------------'
#        configuration=self.editorWindow.configuration
#        configuration.updatedConfigs={}

        # update flags in menus:  CC3DOutputOn, etc. (rf. ViewManager/SimpleViewManager)
        
        
        # Output
        Configuration.setSetting("ScreenUpdateFrequency", self.updateScreenSpinBox.value())
        Configuration.setSetting("ImageOutputOn", self.outputImagesCheckBox.isChecked())
        Configuration.setSetting("SaveImageFrequency", self.saveImageSpinBox.value())
        Configuration.setSetting("LatticeOutputOn", self.outputLatticeDataCheckBox.isChecked())
        Configuration.setSetting("SaveLatticeFrequency", self.saveLatticeSpinBox.value())
        Configuration.setSetting("UseInternalConsole", self.useInternalConsoleCheckBox.isChecked())
        Configuration.setSetting("ClosePlayerAfterSimulationDone", self.closePlayerCheckBox.isChecked())
        Configuration.setSetting("ProjectLocation", self.projectLocationLineEdit.text())
        Configuration.setSetting("OutputLocation", self.outputLocationLineEdit.text())
#        Configuration.setSetting("OutputLocation", self.outputLocLineEdit

        # Cell Type/Colors
        Configuration.setSetting("TypeColorMap",self.paramCC3D["TypeColorMap"])  # rwh
#        Configuration.setSetting("BorderColor", self.cellBorderColorButton
##        Configuration.setSetting("ClusterBorderColor", self.
#        Configuration.setSetting("ContourColor", self.
#        Configuration.setSetting("BrushColor", self.
#        Configuration.setSetting("PenColor", self.

        # Colormap  cmapMinRange
#        print '         self.cmapMinRange.text() = ',self.cmapMinRange.text()
        Configuration.setSetting("MinRange", self.cmapMinRange.text())
        Configuration.setSetting("MinRangeFixed", self.cmapMinRangeFixedCheckBox.isChecked())
        Configuration.setSetting("MaxRange", self.cmapMaxRange.text())
        Configuration.setSetting("MaxRangeFixed", self.cmapMaxRangeFixedCheckBox.isChecked())
        
        Configuration.setSetting("NumberOfLegendBoxes", self.cmapNumLabels.value())  # spinbox
        Configuration.setSetting("NumberAccuracy", self.cmapAccuracy.value())   # spinbox
        Configuration.setSetting("LegendEnable", self.cmapShowCheckBox.isChecked())
        
        Configuration.setSetting("NumberOfContourLines", self.numberOfContoursLinesSpinBox.value())
        Configuration.setSetting("ContoursOn", self.contoursShowCheckBox.isChecked())
        
        # Vectors
#        if configuration.setting("UseTabSpaces")!=self.tabSpacesCheckBox.isChecked():
#            configuration.updatedConfigs["UseTabSpaces"]=self.tabSpacesCheckBox.isChecked()
        Configuration.setSetting("MinMagnitude", self.vectorsMinMag.text())
        Configuration.setSetting("MinMagnitudeFixed", self.vectorsMinMagFixedCheckBox.isChecked())
        Configuration.setSetting("MaxMagnitude", self.vectorsMaxMag.text())
        Configuration.setSetting("MaxMagnitudeFixed", self.vectorsMaxMagFixedCheckBox.isChecked())
        
        Configuration.setSetting("NumberOfLegendBoxesVector", self.vectorsLegendNumLabels.value())
        Configuration.setSetting("NumberAccuracyVector", self.vectorsLegendAccuracy.value())
        Configuration.setSetting("LegendEnableVector", self.vectorsShowLegendCheckBox.isChecked())
        
        Configuration.setSetting("ArrowLength", self.vectorsArrowLength.value())
        Configuration.setSetting("ScaleArrowsOn", self.vectorsScaleArrowCheckBox.isChecked())
        Configuration.setSetting("FixedArrowColorOn", self.vectorsArrowColorCheckBox.isChecked())
        
        Configuration.setSetting("OverlayVectorsOn", self.vectorsOverlayCheckBox.isChecked())

        # 3D
        # Display size, Camera params...
        # Invisible cell types in 3D
        Configuration.setSetting("Types3DInvisible", self.cellTypesInvisibleList.text())
    
    def updateUI(self):
#        print MODULENAME, ' ----------------  updateUI  -------------------------'

        # rwh: what to use: self.paramCC3D[] or Configuration.getSetting?        
        
        self.tabWidget.setCurrentIndex(Configuration.getSetting("TabIndex"))
        
        
        # Output
        self.updateScreenSpinBox.setValue(Configuration.getSetting("ScreenUpdateFrequency"))
#        self.updateScreenSpinBox.setMinimum(1)
        self.outputImagesCheckBox.setChecked(Configuration.getSetting("ImageOutputOn"))
        self.saveImageSpinBox.setValue(Configuration.getSetting("SaveImageFrequency"))
        self.outputImagesClicked()  # enable/disable
#        self.saveImageSpinBox.setMinimum(1)
        self.outputLatticeDataCheckBox.setChecked(Configuration.getSetting("LatticeOutputOn"))
        self.saveLatticeSpinBox.setValue(Configuration.getSetting("SaveLatticeFrequency"))
        self.outputLatticeDataClicked()   # enable/disable
        
        self.useInternalConsoleCheckBox.setChecked(Configuration.getSetting("UseInternalConsole"))
        self.closePlayerCheckBox.setChecked(Configuration.getSetting("ClosePlayerAfterSimulationDone"))
        
        self.projectLocationLineEdit.setText( str(Configuration.getSetting("ProjectLocation")))
        self.outputLocationLineEdit.setText( str(Configuration.getSetting("OutputLocation")))
        
        
        # Cell Type/Colors
#        self.paramCC3D["TypeColorMap"]
        self.populateCellColors()
        # rwh: the following pops up the color selection widget
#        self.selectColor(self.borderColorButton, Configuration.getSetting("BorderColor"))
#        defaultConfigs["BorderColor"] = QColor(Qt.yellow); paramTypeColor.append("BorderColor")
#        defaultConfigs["ContourColor"] = QColor(Qt.white); paramTypeColor.append("ContourColor")
#        defaultConfigs["BrushColor"] = QColor(Qt.white); paramTypeColor.append("BrushColor")
#        defaultConfigs["PenColor"] =

#        palette = QPalette()
#        brush = QBrush(QColor(237,236,235))
#        brush.setStyle(Qt.SolidPattern)
#        palette.setBrush(QPalette.Disabled, QPalette.Window,brush)
#        self.cellBorderColorButton.setPalette(palette)
        
#        color = prefMethod(configColor)
        color = Configuration.getSetting("BorderColor")
        size = self.cellBorderColorButton.size()
#        print '        size w,h=',size.width(),size.height()
        pm = QPixmap(size.width(), size.height())
        pm.fill(color)
        self.cellBorderColorButton.setIconSize(pm.size())
        self.cellBorderColorButton.setIcon(QIcon(pm))
        
        color = Configuration.getSetting("ClusterBorderColor")
        pm = QPixmap(size.width(), size.height())
        pm.fill(color)
        self.clusterBorderColorButton.setIconSize(pm.size())
        self.clusterBorderColorButton.setIcon(QIcon(pm))
        
        color = Configuration.getSetting("ContourColor")
        pm = QPixmap(size.width(), size.height())
        pm.fill(color)
        self.contourColorButton.setIconSize(pm.size())
        self.contourColorButton.setIcon(QIcon(pm))
        
        
        # Colormap
#        self.cmapMinRange.setText(str(self.colormap["MinConcentration"]))
        self.cmapMinRange.setText( str(Configuration.getSetting("MinRange")))
        self.cmapMinRangeFixedCheckBox.setChecked(Configuration.getSetting("MinRangeFixed"))
        self.cmapMinRangeClicked()   # enable/disable
        self.cmapMaxRange.setText( str(Configuration.getSetting("MaxRange")))
        self.cmapMaxRangeFixedCheckBox.setChecked(Configuration.getSetting("MaxRangeFixed"))
        self.cmapMaxRangeClicked()   # enable/disable
        
        self.cmapNumLabels.setValue(self.paramCC3D["NumberOfLegendBoxes"])
        self.cmapAccuracy.setValue(self.paramCC3D["NumberAccuracy"])
        self.cmapShowCheckBox.setChecked(self.paramCC3D["LegendEnable"])
#        
        self.numberOfContoursLinesSpinBox.setValue(self.paramCC3D["NumberOfContourLines"])
        self.contoursShowCheckBox.setChecked(self.paramCC3D["ContoursOn"])
        
        
        # Vectors
        self.vectorsMinMag.setText( str(Configuration.getSetting("MinMagnitude")))
        self.vectorsMinMagFixedCheckBox.setChecked(self.paramCC3D["MinMagnitudeFixed"])
        self.vectorsMinMagClicked()  # enable/disable
        
        self.vectorsMaxMag.setText( str(Configuration.getSetting("MaxMagnitude")))
        self.vectorsMaxMagFixedCheckBox.setChecked(self.paramCC3D["MaxMagnitudeFixed"])
        self.vectorsMaxMagClicked()  # enable/disable
        
        self.vectorsLegendNumLabels.setValue(self.paramCC3D["NumberOfLegendBoxesVector"])
        self.vectorsLegendAccuracy.setValue(self.paramCC3D["NumberAccuracyVector"])
        self.vectorsShowLegendCheckBox.setChecked(self.paramCC3D["LegendEnableVector"])
        
        self.vectorsArrowLength.setValue(self.paramCC3D["ArrowLength"])
        self.vectorsScaleArrowCheckBox.setChecked(self.paramCC3D["ScaleArrowsOn"])
        self.vectorsArrowColorCheckBox.setChecked(self.paramCC3D["FixedArrowColorOn"])
        self.vectorsArrowColorClicked()  # enable/disable
        
        self.vectorsOverlayCheckBox.setChecked(self.paramCC3D["OverlayVectorsOn"])
        
        color = Configuration.getSetting("ArrowColor")
        pm = QPixmap(size.width(), size.height())
        pm.fill(color)
        self.vectorsArrowColorButton.setIconSize(pm.size())
        self.vectorsArrowColorButton.setIcon(QIcon(pm))
        
        
        # 3D
        self.cellTypesInvisibleList.setText(Configuration.getSetting("Types3DInvisible"))

#        configuration=self.editorWindow.configuration
#        self.tabSpacesCheckBox.setChecked(configuration.setting("UseTabSpaces"))
    
    def initParams(self):  # rwh: why the heck should we do this?
#        print MODULENAME, ' initParams -------------------'
        # Output tab
        paramList = ["ImageOutputOn","LatticeOutputOn","ScreenUpdateFrequency","SaveImageFrequency",
                     "UseInternalConsole","UseInternalConsole","ClosePlayerAfterSimulationDone"]
        # Colors tab: cell type, borders, etc
        paramList += ["TypeColorMap","BorderColor","ClusterBorderColor","ContourColor","BrushColor",
                      "PenColor","Types3DInvisible"]
        # Colormap tab
        paramList += ["MinRange","MinRangeFixed","MaxRange","MaxRangeFixed","NumberAccuracy","NumberOfLegendBoxes",
                      "LegendEnable","ContoursOn","NumberOfContourLines"]
        # Vectors tab
        paramList += ["ArrowColor","ArrowLength","FixedArrowColorOn","LegendEnableVector","ScaleArrowsOn",
                      "NumberAccuracyVector","NumberOfLegendBoxesVector","OverlayVectorsOn",
                      "MaxMagnitude","MaxMagnitudeFixed","MinMagnitude","MinMagnitudeFixed"]
        for p in paramList:
            self.paramCC3D[p] = Configuration.getSetting(p)
#            if p == "TypeColorMap":
#                print MODULENAME,'  paramCC3D[TypeColorMap]=',self.paramCC3D[p]
            
            
        # rwh: do we also need to set the widgets here, using the params?
